import __builtin__,cPickle
"""$Id: fphash.py,v 1.1.1.1 2004/03/18 11:59:45 gray Exp $"""

class FPHash:
    """Fast Persistent Hash. Unlike dbm, values are not limited to strings. It is fast
       because all items resides in memory. Nothing is written back to disk until the
       close() method is called."""
    def __init__(self, pfile, flag):
        """loads data in memory"""
        self.pfile = pfile
        self.flag = flag
        if 'c' in flag or 'r' in flag:
            try:
                mfile = __builtin__.open(pfile, 'r')
                self.myhash = cPickle.load(mfile)
                mfile.close()
            except:
                self.myhash = {}
        else:
            self.myhash = {}

    def __len__(self):
        return len(self.myhash)

    def __getitem__(self, key):
        return self.myhash[key]

    def __setitem__(self,key, value):
        self.myhash[key] = value

    def __delitem__(self, key):
        del self.myhash[key]

    def clear(self):
        self.myhash.clear()

    def has_key(self,key):
        return self.myhash.has_key(key)

    def items(self):
        return self.myhash.item()

    def keys(self):
        return self.myhash.keys()

    def update(self, b):
        self.myhash.update(b)

    def values(self):
        return self.myhash.values()

    def get(self, k, x=None):
        return self.myhash.get(k,x)


    def close(self):
        if  'c' in self.flag or 'w' in self.flag:
            mfile = __builtin__.open(self.pfile, 'w')
            cPickle.dump(self.myhash,mfile,1)
            mfile.close()


def open(filename, flag='r'):
    return FPHash(filename, flag)