import struct, socket, os, time
"""$Id: gimpclient.py,v 1.1.1.1 2004/03/18 11:59:45 gray Exp $
A simple class to connect to a Gimp script-fu server and execute script-fu
commands"""

class GimpClient:

    started = None

    def __init__(self):
        self.gs = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    def strtogimp(self, s):
        return 'G'+struct.pack("!h", len(s))+s

    def open(self, h=None, p=None):
        """open a connection to host h, port p if supplied, otherwise start a
new server on the local machine (dangerous)"""
        if h and p:
            self.gs.connect((h,p))
        else:
            # start gimp
            os.system("""gimp -n -b '(extension-script-fu-server 1 10008 "gimplog")'&""")
            time.sleep(10) # wait for the server to be running
            self.gs.connect(('localhost', 10008))
            self.started = 1

    def do(self, cmd):
        """tell the server to execute the command in cmd (i.e. evaluate the
string)"""
        self.gs.send(self.strtogimp(cmd))
        data=""
        while len(data) < 4:
            data = data + self.gs.recv(1024)
        mlen = struct.unpack("!h",data[2:4])[0]
        while len(data) < mlen+4:
            data = data + self.gs.recv(1024)

        if data[1]=='\001':
            raise data[4:]
        else:
            return data[4:]

    def close(self):
        if self.started:
            # self.gs.send(self.strtogimp('(gimp-quit 0)')) # gimp is buggy and may not exit gracefully
            print "You will have to kill gimp manually...(it is a Gimp bug)"
        self.gs.close()




